local UnitIsFriend = _G.UnitIsFriend
local UnitHealth = _G.UnitHealth
local UnitIsPlayer = _G.UnitIsPlayer
local GetTime = _G.GetTime
local abs = _G.abs

local ttd = LibStub("LibDataBroker-1.1"):NewDataObject("Time To Die", {
	icon = "Interface\\Icons\\INV_Misc_PocketWatch_01",
	type = "data source",
	label = "TTD",
	text = "",
})

local eventFrame = CreateFrame("Frame")
eventFrame:Hide()
eventFrame:RegisterEvent("PLAYER_TARGET_CHANGED")
eventFrame:RegisterEvent("UNIT_HEALTH")
eventFrame:SetScript("OnEvent", function(self, event, ...) 
	if event == "UNIT_HEALTH" then ttd:update(arg1)
	elseif event == "PLAYER_TARGET_CHANGED" then ttd:change()
	end
end)

local health0, time0 -- baseline values 
local mhealth, mtime -- midpoint values

function ttd:update(unit)
	if (unit ~= "target") or (UnitIsFriend("player", unit)) or (UnitIsPlayer(unit)) then return end
	
	local health, time = UnitHealth(unit), GetTime()
	
	if not health0 then
		health0, time0 = health, time
		return
	end

	if not mhealth then
		mhealth, mtime = health, time
	else
		mhealth, mtime = (mhealth + health) / 2, (mtime + time) / 2
	end
	
	local dhealth = mhealth - health0

	if dhealth ~= 0 then
		time = health * (time0 - mtime) / dhealth
		if abs(time) > 60 then
			ttd.text = string.format("%dm %ds",time/60, time%60)
		else
			ttd.text = string.format("%ds", time%60)
		end
	else
		ttd.text = "0s"
	end
end

function ttd:change(arg1)
	health0, time0, mhealth, mtime = nil
	ttd.text = ""
end

